.equ	LCD_DEBUG = 0

txtchannel:			.db "Channel "
txtclear16:			.db	"                "
txtclrmodel:		.db " clear? "
txtinputs:			.db	" Inputs "
txtinputs2:			.db	"Inputs 2"
txtoffset:			.db " Offset "
txtoutputs:			.db	"Outputs "
txtselect:			.db " Select "
txtsetmaster:		.db " Master "
txtsetmax:			.db "Set Max "
txtsetmin:			.db "Set Min "
txtsetmodel:		.db "SetModel"
txtmult:			.db	"Multiplier  "
txtsetname:			.db "SetName "
txtwelcome1:		.db "  Master-Slave  "
txtwelcome2:		.db "   Modul V1.1   "
txtwelcome3:		.db "by Joerg Krupar "
txtwelcome4:		.db "     2007       "

		;display routines ASCII display
DISPLAY_INIT:										; initialise the ascii display
		rcall	DELAY_20ms
		push	Temp
	.if DISPLAYBUSWIDTH==4
		ldi		Temp, 0b00001111						; init the DispDataOnes and DispDataZeros registers
		rcall	DISPLAY_L_SHIFT
		sts		DispDataOnes, Temp
		com		Temp									; setup DispDataZeros SRAM register
		sts		DispDataZeros, Temp
	.endif
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		rcall	DISPLAY_PINS_OUT
	.if DISPLAYBUSWIDTH==8
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		ldi		Temp, SetTr8Line2F5x7					; set 8 bit transfer mode and 1 line, 5x7 dot
		rcall	DISPLAY_SEND_CMD
		rcall	DELAY_4ms
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		ldi		Temp, SetTr8Line2F5x7					; set 8 bit transfer mode and 1 line, 5x7 dot
		rcall	DISPLAY_SEND_CMD
	.elif DISPLAYBUSWIDTH==4
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		ldi		Temp, 0b00000011						; first load the 8bit transfer mode
	.if DATAPINSHIFTS>0
		rcall	DISPLAY_L_SHIFT							; move it to the pins
	.endif
		push	Temp2
		push	Temp3
		in		Temp2, PDISPDATA						; prepare the other pins
		lds		Temp3, DispDataZeros
		and		Temp2, Temp3
		or		Temp, Temp2
		out		PDISPDATA, Temp							; write it
		cbi		PDISPRSPORT, DISPRS						; hold RS-Pin low
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		rcall	DISPLAY_PULSEE							; send
		rcall	DELAY_100us								; time for the display
		rcall	DISPLAY_PULSEE							; send
		rcall	DELAY_100us
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		ldi		Temp, 0b00000010						; now it's safe to go into 4-bit mode
	.if DATAPINSHIFTS>0
		rcall	DISPLAY_L_SHIFT							; move it to the pins
	.endif
		in		Temp2, PDISPDATA						; prepare the other pins
		lds		Temp3, DispDataZeros
		and		Temp2, Temp3
		or		Temp, Temp2
		pop		Temp3
		pop		Temp2
		out		PDISPDATA, Temp							; write it
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		rcall	DISPLAY_PULSEE							; send
		rcall	DELAY_100us								; time for the display
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
	.endif
		rcall	DISPLAY_CLEAR
		pop		Temp
		ret
	
DISPLAY_CLEAR:										; clear the display
	.if DISPDATA_MULTIPLEX==1||DISPRS_MULTIPLEX==1||DISPRW_MULTIPLEX==1
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
	.endif
		push	Temp
		ldi		Temp, ClearDisp							; load the clear display command
		rcall	DISPLAY_SEND_CMD
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		rcall	DELAY_4ms								; wait for the display
		ldi		Temp, CursHome							; send the cursor home
		rcall	DISPLAY_SEND_CMD
		rcall	DELAY_4ms								; wait for the display
		pop		Temp
	.if DISPDATA_MULTIPLEX==1||DISPRS_MULTIPLEX==1||DISPRW_MULTIPLEX==1
	.endif
		ret

DISPLAY_PRINT_PM:									; LCD_PrintPM: prints from program memory
														; put the starting memory location in Z (r31:r30)
														; put the number of characters to print in Temp2
														; after execution, Z is at the character AFTER
														; the last to be printed and Temp2 is zero.
														; this function will not wrap if the string
														; is bigger than the LCD.
		push	r0										; r0 is used by lpm command
		push	Temp
 DISPLAY_PM_READ: 
		lpm												; load data adressed by Z into r0
    	mov		Temp, r0								; move it to Temp
		rcall	DISPLAY_SEND_CHAR						; send it to display
		adiw	r30, 1									; increase adress pointer
		dec		Temp2									; decrease number of characters to send
		brne	DISPLAY_PM_READ							; skip if all is sent
		pop		Temp
		pop		r0
		ret

DISPLAY_PRINT_MEM:									; LCD_PrintMem: prints from memory.
														; put the starting memory location in Z (r31:r30)
														; put the number of characters to print in Temp2
														; after execution, Z is at the character AFTER
														; the last to be printed and Temp2 is zero.
														; this function will not wrap if you the string
														; is bigger than the LCD.
		push	Temp
 DISPLAY_MEM_READ: 
   		ld		Temp, Z+								; load data adressed by Z into Temp
		rcall	DISPLAY_SEND_CHAR						; send it to display
		dec		Temp2									; decrease number of characters to send
		brne	DISPLAY_MEM_READ						; skip if all is sent
		pop		Temp
		ret

DISPLAY_SEND_CHAR_NOCHANGE:							; the same as DISPLAY_SEND_CHAR, but Temp is not modified
		push	Temp
		rcall	DISPLAY_SEND_CHAR
		pop		Temp
		ret

DISPLAY_SEND_CHAR:									; send the contents of Temp to the LCD using 8bit mode
		push	Temp2
		in		Temp2, SREG
	.if DISPDATA_MULTIPLEX==1||DISPRS_MULTIPLEX==1||DISPRW_MULTIPLEX==1
		rcall	DISPLAY_PINS_OUT
	.endif

	.if DISPLAYBUSWIDTH==8								; 8bit transfer mode
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		out		PDISPDATA, Temp
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		sbi		PDISPRSPORT, DISPRS						; set data state
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
	.elif DISPLAYBUSWIDTH==4							; 4bit transfer mode
		push 	Temp2
		push	Temp3
		mov 	Temp2, Temp								; make a backup copy for nibble swapping
	.if INTERRUPTS==1
		cli
	.endif
		in		Temp3, PDISPDATA
		lds		Temp, DispDataZeros
		and		Temp3, Temp								; only use the non-data pins
		mov		Temp, Temp2
		andi	Temp, 0b11110000						; only use the upper nibble of Temp
		swap	Temp									; move it to lower outputs
	.if DATAPINSHIFTS>0
		rcall	DISPLAY_L_SHIFT							; move it to the pins
	.endif
		or		Temp, Temp3

	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		out		PDISPDATA, Temp
		sbi		PDISPRSPORT, DISPRS						; set send data state
		rcall 	DISPLAY_PULSEE							; pulse the enable
		in		Temp3, PDISPDATA
		lds		Temp, DispDataZeros
		and		Temp3, Temp								; only use the non-data pins
		mov		Temp, Temp2
		andi	Temp, 0b00001111						; now use the lower nibble
	.if DATAPINSHIFTS>0
		rcall	DISPLAY_L_SHIFT							; move it to the pins
	.endif
		or		Temp, Temp3
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		out		PDISPDATA, Temp
	.if INTERRUPTS==1
		sei
	.endif
		pop		Temp3
		pop 	Temp2
	.endif
		rcall 	DISPLAY_PULSEE							; pulse the enable
		rcall	DELAY_100us
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		cbi		PDISPRSPORT, DISPRS						; unset data state
	.if DISPDATA_MULTIPLEX==1||DISPRS_MULTIPLEX==1||DISPRW_MULTIPLEX==1
		rcall	DISPLAY_PINS_IN
	.endif
		out		SREG, Temp2
		pop		Temp2
		ret

DISPLAY_SEND_CMD:									; LCD_SendCmd: routine to write a command
														; to the instruction register.
														; the value to be written should be stored in Temp.  
														; use the 8bit transfer mode
	.if DISPDATA_MULTIPLEX==1||DISPRS_MULTIPLEX==1||DISPRW_MULTIPLEX==1
		rcall	DISPLAY_PINS_OUT
	.endif
	.if DISPLAYBUSWIDTH==8								; 8bit transfer mode
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		out		PDISPDATA, Temp							; send the command
	.elif DISPLAYBUSWIDTH==4
		push	Temp2
		push	Temp3
		mov 	Temp2, Temp								; make a backup copy
	.if	INTERRUPTS==1
		cli
	.endif
		in		Temp3, PDISPDATA
		lds		Temp, DispDataZeros
		and		Temp3, Temp								; only use the non-data pins
		mov		Temp, Temp2
		andi	Temp, 0b11110000						; only use the upper nibble of Temp
		swap	Temp									; move it to lower outputs
	.if DATAPINSHIFTS>0
		rcall	DISPLAY_L_SHIFT							; move it to the pins
	.endif
		or		Temp, Temp3
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		out		PDISPDATA, Temp
		rcall 	DISPLAY_PULSEE							; pulse the enable
		mov		Temp, Temp2								; now use the lower nibble
		andi	Temp, 0b00001111
	.if DATAPINSHIFTS>0
		rcall	DISPLAY_L_SHIFT							; move it to the pins
	.endif
		or		Temp, Temp3
		out		PDISPDATA, Temp
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
	.if	INTERRUPTS==1
		sei
	.endif
		pop		Temp3
		pop		Temp2
	.endif
		rcall 	DISPLAY_PULSEE							; pulse the enable
		rcall	DELAY_100us
	.if DISPDATA_MULTIPLEX==1||DISPRS_MULTIPLEX==1||DISPRW_MULTIPLEX==1
		rcall	DISPLAY_PINS_IN
	.endif
		ret

DISPLAY_PINS_OUT:									; set all display control and data pins to output
		cbi		PDISPEPORT, DISPE						; set enable to low, output
		sbi		DDISPEPORT, DISPE
		push	Temp
	.if DISPLAYBUSWIDTH==8
		ser		Temp
	.elif DISPLAYBUSWIDTH==4
		lds		Temp, DispDataOnes						; load the data port pins
		push	Temp2
		in		Temp2, DDISPDATA						; read the rest of the port
		or		Temp, Temp2								; set the additional bits high
		pop		Temp2
	.endif
		out		DDISPDATA, Temp							; set the data pins to output
		pop		Temp
		cbi		PDISPRSPORT, DISPRS						; set the RS pin to output, low
		sbi		DDISPRSPORT, DISPRS
	.if RW_SKIP==0
		cbi		PDISPRWPORT, DISPRW						; set the RW pin to output, low
		sbi		DDISPRWPORT, DISPRW
	.endif
		ret

DISPLAY_PINS_IN:									; set all display control and data pins to input, but not the enable pin
	.if DISPDATA_MULTIPLEX==1
		push	Temp
	.if DISPLAYBUSWIDTH==8
		clr		Temp
		out		DDISPDATA, Temp							; set the data pins to output
		out		PDISPDATA, Temp							; disable the pullup
	.elif DISPLAYBUSWIDTH==4
		lds		Temp, DataDispZeros						; load the data pins to be set zero
		push	Temp2
		in		Temp2, DDISPDATA						; read the rest of the port
		and		Temp2, Temp								; set the data pins low
		out		DDISPDATA, Temp							; set the data pins to input
		in		Temp2, PDISPDATA
		and		Temp2, Temp								; set the data pins low
		out		PDISPDATA, Temp							; disable the pullup
		pop		Temp2
	.endif
		pop		Temp
	.endif
	.if DISPRS_MULTIPLEX==1
		cbi		DDISPRSPORT, DISPRS						; set the RS pin to input
	.endif
	.if RW_SKIP==0
	.if DISPRW_MULTIPLEX==1
		cbi		DDISPRWPORT, DISPRW						; set the RW pin to input
	.endif
	.endif
		ret

	.if DISPLAYBUSWIDTH==4								; this command is only reqiured in 4bit transfer mode
DISPLAY_L_SHIFT:									; shift the Temp register DATAPINSHIFTS times
	.if	DATAPINSHIFTS==0								; no shifts in this case
		ret
	.elif DATAPINSHIFTS<4
		push	Temp2
		ldi		Temp2, DATAPINSHIFTS					; load the number of shifts
		clc												; clear carry flag before rolling
 DISPLAY_L_SHIFT_GO:
		rol		Temp									; shift left
		dec		Temp2									; decrease shift counter
		brne	DISPLAY_L_SHIFT_GO						; shift until counter is zero
		pop		Temp2
	.elif DATAPINSHIFTS==4
		swap	Temp
	.endif
		ret
	.endif

DISPLAY_PULSEE:										; toggle the display enable pin
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		sbi		PDISPEPORT, DISPE						; set enable high
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		nop												; wait
		cbi		PDISPEPORT, DISPE						; set enable low
	.if	LCD_DEBUG==1
		rcall	DELAY_1s
	.endif
		ret
