		; data bus width of the display
.equ		DISPLAYBUSWIDTH = 4							; transfer mode, 8bit or 4bit
.equ		DATAPINSHIFTS	= 1							; shift the data pins xx 0..3 times left in 4bit transfer mode, number between 0 and 4
.equ		RW_SKIP			= 1							; if 1 RW pin is connected to gnd and not used by software
		; pins display
.equ		PDISPDATA	= PORTB							; data port for the display
.equ		DDISPDATA	= DDRB							; pin directions, display data port
.equ		PINDISPDATA = PINB
.equ		PDISPRSPORT	= PORTD							; RS pin
.equ		DDISPRSPORT	= DDRD
.equ		DISPRS		= 4
.if RW_SKIP==0
.equ		PDISPRWPORT	= PORTD							; RW pin
.equ		DDISPRWPORT	= DDRD
.equ		DISPRW		= 5
.endif
.equ		PDISPEPORT	= PORTD							; enable pin
.equ		DDISPEPORT	= DDRD
.equ		DISPE		= 5

		; display pins multiplex/share with other hardware
.equ		DISPDATA_MULTIPLEX	= 0						; share the display data port
.equ		DISPRS_MULTIPLEX	= 0						; share the RS pin
.equ		DISPRW_MULTIPLEX	= 0						; share the RW pin

		;display commands ASCII display
;.equ		Trans4Bit		= 0b00000010				; 4 bit transfer mode command, 50us

.equ		ClearDisp		= 0b00000001				; clear display command, 2ms
.equ		CursHome		= 0b00000010				; send cursor home command, 2ms
			; *** 'ENTRY MODE' command
			;						  +--- shift direction: 0 = left; 1 = right
				;					  |+-- shift what: 0 = cursor; 1 = display
.equ		EntryCursLeft	= 0b00000100				; entry mode: shift the cursor left
.equ		EntryCursRight	= 0b00000110				; entry mode: shift the cursor right
.equ		EntryDispLeft	= 0b00000101				; entry mode: shift the display left
.equ		EntryDispRight	= 0b00000100				; entry mode: shift the display right
			; ***  'DISPLAY ON/OFF' command
					;                +---- display: 0 = off; 1 = on
					;                |+--- cursor: 0 = off; 1 = on
					;                ||+-- blink: 0 = off; 1 = on
.equ		DispOffCursOff	= 0b00001000				; display/cursor on/off/blinking command
.equ		DispOffCursOn	= 0b00001010
.equ		DispOffCursLBl	= 0b00001011
.equ		DispOffCursSBl	= 0b00001001
.equ		DispOnCursOff	= 0b00001100
.equ		DispOnCursOn	= 0b00001110
.equ		DispOnCursLBl	= 0b00001111
.equ		DispOnCursSBl	= 0b00001101
			; ***  'CURSOR/DISPLAY SHIFT' command
					;               +----- S/C:  0 = cursor; 1 = display
					;		        |+---- R/L:  0 = left; 1 = right
.equ		ShCursLeft		= 0b00010000
.equ		ShCursRight		= 0b00010100
.equ		ShDispLeft		= 0b00011000
.equ		ShDispRight		= 0b00011100
			; ***  'SET FUNCTION'
					;              +------ transfer mode, 1 = 8bit; 0 = 4bit
					;              |+----- display lines, 1 = 2lines; 0 = 1line
					;              ||+---- display format, 1 = 5x10dot; 0 = 5x7dot
.equ		SetTr8Line1F5x7	= 0b00110000
.equ		SetTr8Line2F5x7	= 0b00111000
.equ		SetTr8Line1F5x10= 0b00110100
.equ		SetTr8Line2F5x10= 0b00111100


							;   +--------- set DD adress command
.equ		Start1Line		= 0b10000000
.equ		Start2Line		= 0b11000000	; 40h is beginning of second line
.equ		Start3Line		= 0b10010000
.equ		Start4Line		= 0b11010000
.equ		Mid1Line		= 0b10001000
.equ		Mid2Line		= 0b11001000
.equ		Mid3Line		= 0b10011000
.equ		Mid4Line		= 0b11011000

;	.endif
