; conversion routines

CONV_SBYTE_DECDISP:									; convert singed 8 bit integer in Temp to a displayable number and send it to the display
														; needs 4 characters (-127..127)
		push	Temp2
		sbrc	Temp, 7									; test for negative numbers
		rjmp	CSBDD_NEG
		push	Temp
		ldi		Temp, 0b00100000						; send a space character
		rjmp	CSBDD_POS
 CSBDD_NEG:												; negative
		neg		Temp									; make it positive
		push	Temp
		ldi		Temp, 0b00101101						; send a "-"
 CSBDD_POS:
		rcall	DISPLAY_SEND_CHAR						; send it
		pop		Temp
		cpi		Temp, 100
		brlo	CSBDD_S100								; test if smaller than 100
		ldi		Temp2, 100								; larger than 100, subtract 100
		sub		Temp, Temp2
		push	Temp
		ldi		Temp, 0b00110001						; send a "1" to the display
		rjmp	CSBDD_10								; go on
 CSBDD_S100:											; smaller than 100
		push	Temp
		ldi		Temp, 0b00100000						; send a space to the display
 CSBDD_10:
		rcall	DISPLAY_SEND_CHAR						; send the character
		pop		Temp
		ldi		Temp2, 10
		rcall	DIVIDEU8								; get the 10er multiplier
		push	Temp
		ldi		Temp, 0b00110000
		add		Temp, Temp2								; convert to ASCII character
		rcall	DISPLAY_SEND_CHAR						; send it
		pop		Temp
		ldi		Temp2, 0b00110000
		add		Temp, Temp2								; convert last letter to ASCII
		rcall	DISPLAY_SEND_CHAR
		pop		Temp2
		ret

CONV_UBYTE_DECDISP:									; convert unsinged 8 bit integer in Temp to a displayable number and send it to the display
		push	Temp2
		push	Temp
		ldi		Temp, 0b00100000						; send a space character
		rcall	DISPLAY_SEND_CHAR						; send it
		pop		Temp
		cpi		Temp, 200
		brlo	CUBDD_S200
		ldi		Temp2, 200
		sub		Temp, Temp2								; larger than 200, subtract 200
		push	Temp
		ldi		Temp, 0b00110010						; send a "2" to the display
		rjmp	CUBDD_10
 CUBDD_S200:
		cpi		Temp, 100
		brlo	CUBDD_S100								; test if smaller than 100
		ldi		Temp2, 100								; larger than 100, subtract 100
		sub		Temp, Temp2
		push	Temp
		ldi		Temp, 0b00110001						; send a "1" to the display
		rjmp	CUBDD_10								; go on
 CUBDD_S100:											; smaller than 100
		push	Temp
		ldi		Temp, 0b00100000						; send a space to the display
 CUBDD_10:
		rcall	DISPLAY_SEND_CHAR						; send the character
		pop		Temp
		ldi		Temp2, 10
		rcall	DIVIDEU8								; get the 10er multiplier
		push	Temp
		ldi		Temp, 0b00110000
		add		Temp, Temp2								; convert to ASCII character
		rcall	DISPLAY_SEND_CHAR						; send it
		pop		Temp
		ldi		Temp2, 0b00110000
		add		Temp, Temp2								; convert last letter to ASCII
		rcall	DISPLAY_SEND_CHAR
		pop		Temp2
		ret

.if 1==1
CONV_BYTE_TO_BIN_DISP:								; convert a byte in Temp into 8 bytes for displaying with ascii display and send it to the ascii display
		push	Temp
		push	Temp2
		push	Temp3
		ldi		Temp3, 8								; load the shift counter
		mov		Temp2, Temp
 CONV_BYTE_TO_BIN_DISP_GO:
		ldi		Temp, 0b0110000							; load "0" as default
		sbrc	Temp2, 7								; test if msb 1
		ldi		Temp, 0b00110001						; load "1" if bit is 1
		rcall	DISPLAY_SEND_CHAR						; send the "1" or "0" to the display
		rol		Temp2									; rotate the value left
		dec		Temp3									; decrease the shift counter
		brne	CONV_BYTE_TO_BIN_DISP_GO				; run the loop 8 times
		pop		Temp3
		pop		Temp2
		pop		Temp
		ret
.endif

.if 0==1
CONV_BYTE_TO_HEX:									; convert a byte in Temp into a hex sign to be stored in Z, Z+1
		ret
.endif


.if 0==1
CONV_BYTE_TO_HEXDISP:
		push	Temp
		in		Temp, SREG
		push	Temp
		push	Temp2
		lds		Temp, SerData							; load the serial data
		andi	Temp, 0b00001111						; use the lower nibble
		cpi		Temp, 10
		brlo	C_BYTE_HEXDISP_LESS101
		ldi		Temp2, 0b01000001						; load "A"
		subi	Temp2, 10
		rjmp	C_BYTE_HEXDISP_STORE1					; convert to letters
 C_BYTE_HEXDISP_LESS101:
		ldi		Temp2, 0b00110000						; load "0"
 C_BYTE_HEXDISP_STORE1:
		add		Temp, Temp2
		st		-Z, Temp								; store the result with pre-decrement
		lds		Temp, SerData							; restore last result
		swap	Temp									; swap upper and lower nibble
		andi	Temp, 0b00001111						; use the lower nibble
		cpi		Temp, 10
		brlo	C_BYTE_HEXDISP_LESS102
		ldi		Temp2, 0b01000001						; load "A"
		subi	Temp2, 10
		rjmp	C_BYTE_HEXDISP_STORE2					; convert to letters
 C_BYTE_HEXDISP_LESS102:
		ldi		Temp2, 0b00110000						; load "0"
 C_BYTE_HEXDISP_STORE2:
		add		Temp, Temp2
		st		-Z, Temp								; store the result
		andi	Status1, 0b11111011						; reset the conversion bit
		cpi		ZH, HIGH(Disp1)							; test if all data converted
		brne	CBHD_OUT
		cpi		ZL, LOW(Disp1)
		brne	CBHD_OUT
		ori		Status1, 0b00001000						; set all data converted state
		andi	Status1, 0b11111000
 CBHD_OUT:
		pop		Temp2
		pop		Temp
		out		SREG, Temp
		pop		Temp
		ret
.endif

.if 0==1
MULTIPLY:											; multiplies ConvNib1..5 with 17 bits of MulDiv1..3
														; result is stored in ConvRes1..5
														; ConvNib is NOT saved!!
		push	Temp
		ldi		Temp, 17								; multpplier is 17 bit
 MULTIPLY_INNER:										;loop
 		sbrs	MulDiv1, 0								; test if bit 1
		rjmp	MULTIPLY_NO								; no, dont multiply
 		add		ConvRes1, NibConv1
		adc		ConvRes2, NibConv2
		adc		ConvRes3, NibConv3
		adc		ConvRes4, NibConv4
		adc		ConvRes5, NibConv5
 MULTIPLY_NO:
 		lsl		NibConv1								; prepare next step
		rol		NibConv2								; shift count
		rol		NibConv3
		rol		NibConv4
		rol		NibConv5
		lsr		MulDiv3									; shift multpplier
		ror		MulDiv2
		ror		MulDiv1
		dec		Temp									; decrease bit counter
		brne	MULTIPLY_INNER							; go on if bits there
		pop		Temp
		ret
.endif

DIVIDEU8:											; divide Temp by Temp2, result is stored in Temp2, rest is stored in Temp
														; all registers contain unsined integer numbers
		push	Temp3
		push	Temp4
		clr		Temp4
		ldi		Temp3, 1
		sbrc	Temp2, 7								; skip shifting if MSB is one
		rjmp	DU8_DIV
 DU8_SHIFT_LEFT:
		lsl		Temp2
		inc		Temp3
		sbrs	Temp2, 7								; shift left until MSB is one
		rjmp	DU8_SHIFT_LEFT
 DU8_DIV:
		lsl		Temp4									; multiply result by 2
		cp		Temp, Temp2
		brlo	DU8_DIV_AFTER							; only do if larger
		sub		Temp, Temp2
		inc		Temp4
 DU8_DIV_AFTER:
		lsr		Temp2									; divide divisor by 2
		dec		Temp3
		brne	DU8_DIV									; repeat until all shifts finished
		mov		Temp2, Temp4
		pop		Temp4
		pop		Temp3
		ret

.if 0==1
DIVIDE:												; divide ConvRes1..5 by 17 bits of MulDiv1..3
		push	Temp
		push	Temp2
		ldi		MulDiv5, 0x0C							; this is already the shifted divisor!
		ldi		MulDiv4, 0x4D
		ldi		MulDiv3, 0x98
		clr		MulDiv2
		clr		MulDiv1
		lsr		MulDiv5
		ror		MulDiv4
		ror		MulDiv3
		clr		NibConv1								; clear result registers
		clr		NibConv2
		clr		NibConv3
		clr		NibConv4
		clr		NibConv5
		ldi		Temp, 19								; 36-17=19 counts of shifts until original
														; divisor achieved
 DIVIDE_INNER:											; inner dividion loop
 		lsl		NibConv1								; shift result register 1 left
		rol		NibConv2
		rol		NibConv3								; 3 registers are enough for 19 shifts
		ori		Temp2, 0b00000001						; first set last bit
 		sub		ConvRes1, MulDiv1						; compare the counts
		sbc		ConvRes2, MulDiv2
		sbc		ConvRes3, MulDiv3
		sbc		ConvRes4, MulDiv4
		sbc		ConvRes5, MulDiv5
		brsh	DIVIDE_INNER_NOUNDO						; dont restore value if carry not set
		andi	Temp2, 0b00000000						; reset last bit, not divided
		add		ConvRes1, MulDiv1						; undo subtraction
		adc		ConvRes2, MulDiv2
		adc		ConvRes3, MulDiv3
		adc		ConvRes4, MulDiv4
		adc		ConvRes5, MulDiv5
 DIVIDE_INNER_NOUNDO:
 		or		NibConv1, Temp2							; add the resulting lsb
 		lsr		MulDiv5									; shift divisor 1 right
		ror		MulDiv4
		ror		MulDiv3
		ror		MulDiv2
		ror		MulDiv1
		dec		Temp									; decrease loop counter
		brsh	DIVIDE_INNER							; run until counter zero
		pop		Temp2
		pop		Temp
		ret
.endif
