; delay routines
.equ	DELAY_OFF = 0									; switch delays off for simulation purposes

.equ	ipus=CPUFREQ/1000								; CPU frequency/number of instructions per us to calculate the delay counters


DELAY_1s:											; provide 1s delay
	.if	DELAY_OFF==0
		push	Temp
		ldi		Temp, 250
 DELAYCOUNT1s:
		rcall	DELAY_4ms
		dec		Temp
		brne	DELAYCOUNT1s
		pop		Temp
	.endif
		ret

.if	ipus<=9
DELAY_20ms:											; provide 20ms delay
	.if	DELAY_OFF==0
		push	Temp
		ldi		Temp, (20000/778)*ipus
 DELAYCOUNT20ms:
 		rcall	DELAY775
 		dec		Temp									; 1MZ
		brne	DELAYCOUNT20ms							; 1/2MZ
		pop		Temp									; 2MZ
	.endif
		ret												; 3MZ, rcall 3MZ
.else
DELAY_20ms:
	.if	DELAY_OFF==0
		push	Temp
		ldi		Temp, 5
 DELAYCOUNT20ms:
 		rcall	DELAY_4ms
 		dec		Temp									; 1MZ
		brne	DELAYCOUNT20ms							; 1/2MZ
		pop		Temp									; 2MZ
	.endif
		ret												; 3MZ, rcall 3MZ
.endif

.if ipus<=12
DELAY_4ms:											; provide 4ms delay
	.if	DELAY_OFF==0
		push	Temp
		ldi		Temp, (4000/203)*ipus
 DELAYCOUNT4ms:
 		rcall	DELAY200
 		dec		Temp									; 1MZ
		brne	DELAYCOUNT4ms							; 1/2MZ
		pop		Temp									; 2MZ
	.endif
		ret												; 3MZ, rcall 3MZ
.else
DELAY_4ms:
	.if	DELAY_OFF==0
		push	Temp
		ldi		Temp, (4000/778)*ipus
 DELAYCOUNT4ms:
 		rcall	DELAY775
 		dec		Temp									; 1MZ
		brne	DELAYCOUNT4ms							; 1/2MZ
		pop		Temp									; 2MZ
	.endif
		ret												; 3MZ, rcall 3MZ
.endif

DELAY_100us:										; provide 100us delay
	.if DELAY_OFF==0
		push	Temp
	.if CPUFREQ<7600
		ldi		Temp, (100/3)*ipus
	.else
		ldi		Temp, (100/7)*ipus
	.endif
 DELAYCOUNT100us:
	.if	CPUFREQ>=7600
		nop
		nop
		nop
		nop
	.endif
		dec		Temp
		brne	DELAYCOUNT100us
		pop		Temp
	.endif
		ret

DELAY775:											; provide 775 MZ delay including the rcall command
	.if	DELAY_OFF==0
		push	Temp									; 2MZ
		ldi		Temp, 255								; 1MZ
 DELAYCOUNT775:
 		dec		Temp									; 1MZ
		brne	DELAYCOUNT775							; 1/2MZ
		pop		Temp									; 2MZ
	.endif
		ret												; 3MZ, rcall 3MZ

DELAY200:											; provide 200 MZ delay
	.if	DELAY_OFF==0
		push	Temp									; 2MZ
		ldi		Temp, 58								; 1MZ
 DELAYCOUNT200:
 		dec		Temp									; 1MZ
		brne	DELAYCOUNT200							; 1/2MZ
		pop		Temp									; 2MZ
	.endif
		ret												; 3MZ, rcall 3MZ

